/**
 * @file
 * Provides mobile toggler for the the Ultimenu main block.
 */

(function ($, Drupal, window, document) {

  "use strict";

  Drupal.ultimenu = Drupal.ultimenu || {};
  var ultimenuTimer;

  Drupal.behaviors.ultimenu = {
    attach: function (context) {

      $('#button-navigation').once('ultimenu').click(function (e) {
          e.preventDefault();
          $(this).toggleClass('js-ultimenu-button-active');
          $('body').toggleClass('js-ultimenu-expanded');
          $('#ultimenu-main .ultimenu__link').removeClass('js-ultimenu-active').next('.ultimenu__flyout').slideUp();
          $($(this).data('target')).not(':animated').slideToggle();
      });

      $('#ultimenu-main').once('ultimenu-main', function () {
        var t = $(this),
          $link = t.find('.ultimenu__link');
        if (!$link.find('.caret').length) {
          $link.append('<span class="caret" />');
        }

        t.on('click', '.caret', function (e) {
          e.preventDefault();
          $(this).parent().toggleClass('js-ultimenu-active');
          $(this).parent().next('.ultimenu__flyout').not(':animated').slideToggle();
        });
      });

      $(window).off('resize.ultimenu').on('resize.ultimenu', function () {
        clearTimeout(ultimenuTimer);
        ultimenuTimer = setTimeout(Drupal.ultimenu.ultimenuMain, 100);
      });
    }
  };

  Drupal.ultimenu.ultimenuMain = function() {
    if ($('#button-navigation').is(':hidden')) {
      $('body').removeClass('js-ultimenu-expanded');
      $('#ultimenu-main').show();
    }
  };

})(jQuery, Drupal, this, this.document);
